﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace Fi.Partners.Plugins.Traffic.TimeArithmetic
{
	public class ColonTimeValueNode : AstNode
	{
		public int Hours { get; private set; }
		public int Minutes { get; private set; }

		public override void Init(Irony.Ast.AstContext context, Irony.Parsing.ParseTreeNode treeNode)
		{
			base.Init(context, treeNode);

			Hours = int.Parse(treeNode.ChildNodes[0].FindTokenAndGetText());
			Minutes = int.Parse(treeNode.ChildNodes[2].FindTokenAndGetText());
		}

		protected override object DoEvaluate(Irony.Interpreter.ScriptThread thread)
		{
			return (Hours * 60) + Minutes;
		}
	}
}
