﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace Fi.Partners.Plugins.Traffic.TimeArithmetic
{
	public class HourMinuteTimeValueNode : AstNode
	{
		private AstNode HoursNode;
		private AstNode MinutesNode;

		public override void Init(Irony.Ast.AstContext context, Irony.Parsing.ParseTreeNode treeNode)
		{
			base.Init(context, treeNode);

			HoursNode = AddChild("Hours", treeNode.ChildNodes[0]);
			MinutesNode = AddChild("Minutes", treeNode.ChildNodes[1]);
		}

		protected override object DoEvaluate(Irony.Interpreter.ScriptThread thread)
		{
			return (int)HoursNode.Evaluate(thread) + (int)MinutesNode.Evaluate(thread);
		}
	}
}

