﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace Fi.Partners.Plugins.Traffic.TimeArithmetic
{
	public class HourValueNode : AstNode
	{
		public decimal Hours { get; private set; }

		public override void Init(Irony.Ast.AstContext context, Irony.Parsing.ParseTreeNode treeNode)
		{
			base.Init(context, treeNode);

			Hours = decimal.Parse(treeNode.ChildNodes[0].FindTokenAndGetText());
		}

		protected override object DoEvaluate(Irony.Interpreter.ScriptThread thread)
		{
			return (int)(Hours * 60);
		}
	}
}
