﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Parsing;
using Irony.Interpreter;

namespace Fi.Partners.Plugins.Traffic.TimeArithmetic
{
	public class TimeCalculator
	{
		private static TimeCalculatorGrammar _grammar = new TimeCalculatorGrammar();

		public static bool IsValid(string expression)
		{
			LanguageData language = new LanguageData(_grammar);
			Parser parser = new Parser(language);
			ParseTree parseTree = parser.Parse(expression);
			ParseTreeNode root = parseTree.Root;

			return root != null;
		}

		public static TimeSpan Evaluate(string expression)
		{
			LanguageData language = new LanguageData(_grammar);
			
			Parser parser = new Parser(language);
			ParseTree parseTree = parser.Parse(expression);
			ParseTreeNode root = parseTree.Root;

			ScriptApp app = new ScriptApp(language);
			ScriptThread thread = new ScriptThread(app);

			int minutes = (int)app.Evaluate(parseTree);

			return TimeSpan.FromMinutes(Math.Max(0, minutes));
		}
	}
}
